use std::fs::File;
use std::cmp;
use std::io::{self, prelude::*, BufReader};



fn process_text(mut wall_of_text: Vec<String>) -> u32 {
    let mut map_start = 0;
    let mut map_end = 0;
    let length = wall_of_text.len();
    let mut answer = 0;
    for line in 1..length{
        for column in 0..wall_of_text[line].len(){
            if wall_of_text[line].get(column..column+1).unwrap() == "O"{
                wall_of_text[line].replace_range(column..column+1, ".");
                for i in (0..line).rev(){
                    if wall_of_text[i].get(column..column+1).unwrap() == "#" || wall_of_text[i].get(column..column+1).unwrap() == "O"{
                        wall_of_text[i+1].replace_range(column..column+1, "O");
                        break;
                    }
                    else if i == 0  {
                        wall_of_text[i].replace_range(column..column+1, "O");
                    }
                }
            }
        }
    }

    for line in 0..length{
        for column in 0..wall_of_text[line].len(){
            if wall_of_text[line].get(column..column+1).unwrap() == "O"{
                answer += length-line;
            }
        }
    }
    println!("{wall_of_text:?}");

    return answer.try_into().unwrap();
}

fn main() -> io::Result<()>  {
    let file = File::open("../input.txt")?;
    let reader = BufReader::new(file);
    let answer = process_text(
        reader.lines().collect::<io::Result<Vec<String>>>().expect("failed")
    );
    println!("{}", answer);
    

    Ok(())
}
